/**********************************************************************
 * pop3_token.h                                              March 1999
 * Horms                                            horms@verge.ing.to.
 * Verge Systems International                http://www.verge.ing.to./
 *
 **********************************************************************/

#ifndef POP3_TOKEN_BLUM
#define POP3_TOKEN_BLUM

#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <ctype.h>

#include "queue.h"
#include "log.h"
#include "strn_to_str.h"

#define BUFFER_SIZE 1024
#define GREETING "POP3 Ready"
#define OK "+OK"
#define ERR "-ERR"

#define DESTROY_POP3_TOKEN (void (*)(const void *))destroy_pop3_token
  
typedef struct{
  ssize_t n;
  unsigned char * buf;
  int eol;
}pop3_token;

pop3_token *create_pop3_token(pop3_token *token);

void assign_pop3_token(
  pop3_token *token,
  unsigned char * buf,
  ssize_t n,
  int eol
);

void unassign_pop3_token(pop3_token *token);

void destroy_pop3_token(pop3_token *token);

int write_pop3_token(int fd, pop3_token *token);

int write_strings(int fd, int nostring, ...);

pop3_token *read_pop3_token(int fd, pop3_token *token);

queue *read_pop3_line(int fd, queue *q);

int eol_pop3_token(pop3_token *token);

int pop3_token_cmp(pop3_token *a, pop3_token *b);

char *pop3_token_to_string(pop3_token *token, char *string);

#endif
