/**********************************************************************
 * tcp_socket_pipe.c                                         April 1999
 * Horms                                            horms@verge.ing.to.
 * Verge Systems International                http://www.verge.ing.to./
 *
 **********************************************************************/

#include "tcp_socket_pipe.h"

void tcp_socket_pipe(
  int fd_a_in, 
  int fd_a_out, 
  int fd_b_in, 
  int fd_b_out, 
  unsigned char *buffer, 
  int buffer_length
){
  fd_set read_template;
  
  for(;;){
    FD_ZERO(&read_template);
    FD_SET(fd_a_in, &read_template);
    FD_SET(fd_b_in, &read_template);

    if(select(FD_SETSIZE,&read_template,(fd_set *)0,(fd_set *)0,NULL)<0){
      if(errno!=EINTR){
        syslog(LOG_WARNING, "select: %s, Exiting", strerror(errno));
        exit(-1);
      }
      return;
    }
    else if(FD_ISSET(fd_a_in, &read_template)){
      if(tcp_socket_pipe_read_write(fd_a_in,fd_b_out,buffer,buffer_length)<0){
        return;
      }
    }
    else if(FD_ISSET(fd_b_in, &read_template)){
      if(tcp_socket_pipe_read_write(fd_b_in,fd_a_out,buffer,buffer_length)<0){
        return;
      }
    }
  }
}


int tcp_socket_pipe_read_write(
  int in_fd, 
  int out_fd, 
  unsigned char *buffer, 
  int buffer_length
){
  int bytes;

  bytes=read(in_fd, buffer, buffer_length);
  if(bytes<=0){
    return(-1);
  }
  write(out_fd, buffer, bytes);

  return(0);
}

