/**********************************************************************
 * tcp_socket_server.c                                       April 1999
 * Horms                                            horms@verge.ing.to.
 * Verge Systems International                http://www.verge.ing.to./
 *
 **********************************************************************/

#include "tcp_socket_server.h"

int tcp_socket_server_connect(char *port){
  int s;
  int g;
  int addrlen;
  struct sockaddr_in from;

  if((s=socket(AF_INET, SOCK_STREAM, 0)) < 0){
    syslog(
      LOG_WARNING, 
      "tcp_socket_server_connect: socket: %s, Exiting",
      strerror(errno)
    );
    exit(1);
  }

  from.sin_family = AF_INET;
  from.sin_port = htons(atoi(port));
  from.sin_addr.s_addr = htonl(INADDR_ANY);
  addrlen = sizeof(from);

  if(bind(s, (struct sockaddr *)&from, addrlen)<0){
    syslog(
      LOG_WARNING, 
      "tcp_socket_server_connect: bind: %s, Exiting",
      strerror(errno)
    );
    exit(1);
  }

  signal(SIGCHLD, (void(*)(int))tcp_socket_server_reaper);
  listen(s, 5);

  for(;;){
    if((g=accept(s, (struct sockaddr *)&from, &addrlen))<0){
       if(errno!=EINTR){
        syslog(
	  LOG_WARNING, 
	  "tcp_socket_server_connect: accept: %s, Exiting",
	  strerror(errno)
	);
        exit(1);
      }
    }
    else{
      if(fork()==0){
        if(close(s)<0){
          syslog(
	    LOG_WARNING, 
	    "tcp_socket_server_connect: close, Exiting",
	    strerror(errno)
	  );
          exit(1);
        }
        return(g);
      }
      else{
        if(close(g)){
          syslog(
	    LOG_WARNING, 
	    "tcp_socket_server_connect: close: %s, Exiting",
	    strerror(errno)
	  );
          exit(1);
        }
      }
    }
  }
}

int tcp_socket_server_reaper(void){
  union wait status;

  signal(SIGCHLD, (void(*)(int))tcp_socket_server_reaper);
  while(wait3(&status, WNOHANG, 0)>0){
    ;
  }
  
  return(0);
}
